package andromedajade.demo;

import android.content.Intent;
import android.util.Log;
import andromeda.core.*;
import andromeda.core.tasks.Task;
import andromeda.lang.acl.ACLMessage;
import andromeda.lang.acl.MessageTemplate;

public class tarea1 extends Task {
	private static final int MIN = 10000;  //10Seg
	@Override
	public void execute() {
		
		Intent view =new Intent("android.Andromeda.VIEW");				
		Intent progress =new Intent("android.Andromeda.PROGRESS");	

		//no activate mDNS (discovery) => still does not work on some HTC phones 
		//agent address in JADE PLATFORM 
        AID agentReceiver = agentGUI.agentJADE;
				
		//Start Message
        ACLMessage  msg = new ACLMessage(ACLMessage.INFORM);
        msg.setContent("Start");
	    msg.setProtocol("START_BUY");
        msg.setSender(agentGUI.getAID());    //comment to use on the cellular phone
	    
	    msg.addReceiver(agentReceiver);
	    send(msg);
	    
	    //Log.i("AGENT", msg.toString());	
	    
	    progress.putExtra("value", "on");
	    progress.putExtra("message", "Buy starting. Please wait...");
    	sendBroadcast(progress);
	    
	    //wait the response of START_BUY msg
		//msg = null;
		msg = blockReceive(MIN);  //EnterBuyOK
		
        if ((msg != null) && (msg.getContent().contains("OK"))) { 
        	//Msg OK
         	Log.i("AGENT", "RECEIVE: " + msg.toString());          	
         }else {
         	Log.i("AGENT", "the message_1 was not received");
        }
        
        //wait for the first offer 
        //msg = null;
        MessageTemplate template = MessageTemplate.MatchProtocol("BUY_PROTOCOL");
        msg = blockReceive(template, MIN);  //BUY_PROTOCOL
        //msg.setPerformative(ACLMessage.INFORM);
        //msg.setContent("[X-Engine, X-Skeleton, Monitor]:-3888.8888888888887");
    	
        progress.putExtra("value", "off");
    	sendBroadcast(progress);
        //send the goods of agent
        if (msg != null) {
        	//Log.i("AGENT", "RECIBIENDO: " + msg.toString());
        	view.putExtra("content", msg.getContent());
        	sendBroadcast(view);
        }else {
         	Log.i("AGENT", "the message_2 was not received");
        }
  
        //The execution can be performed on this 
        //task (Tarea 1), however Tarea 2 is used to illustrate the model.
	}

	@Override
	public boolean done() {
			Log.i("AGENT", "End the tarea1");
			return true;

	}
///*
// * ***********************************************
// * Only for the emulator, because you have to 
// * override the emulator private IP  (10.0.2.15) 
// * by the Host IP.
// * 
// * Remember to use the console command 
// * to redirect the private port by the port on the host
// * # telnet localhost 5554
// *    redir add tcp:9090:9090
// *     
// * Comment to use in the cellular phone
// * ***********************************************
//*/
//
//	public AID getAID(){
//		//Only by the Emulator and JADE
//		AID agentSender = new AID();
//		agentSender.setName("AndroClient@andromeda");
//		//agentSender.addAddresses("http://MYIPADDRESS:9090/");  //communication between HOST-to-HOST
//		agentSender.addAddresses("http://localhost:9090/"); //communication in localhost
//		return agentSender;
//		
//	}

}
